---
title: "What are the best and worst parts about being a development team lead?"
author: Katherine Okpara
author_gitlab: katokpara
author_twitter: gitlab
categories: engineering
image_title: '/images/blogimages/inside-our-new-development-team-lead-persona.jpg'
description: "Dev leads, we feel you. Here's a deep dive into our interviews with development team leads, and the new persona they informed."
tags: engineering, workflow, UX
ee_cta: false
---

Welcome back to our series on the [new GitLab personas](/handbook/marketing/strategic-marketing/roles-personas/)! I recently [wrote about what we learned from product managers during interviews](/blog/2018/11/12/inside-our-new-product-manager-persona/) for our [UX research project to develop personas](https://gitlab.com/gitlab-org/ux-research/issues/77) for all product areas. In this post, I'll share some of the insights from our efforts to better understand development team leads, and introduce the resulting persona, [Delaney](/handbook/marketing/strategic-marketing/roles-personas#delaney-development-team-lead).

## The research

Here are some of the findings from my [six interviews](https://gitlab.com/gitlab-org/ux-research/issues/95) conducted for the persona.

Development team leads are often responsible for meeting with product managers and stakeholders to discuss scheduled feature requests, convert concepts into practical solutions, ensure that capacity is properly estimated, and assign work to developers. They are also involved in other duties such as creating design and functional specifications, writing code, documenting and automating processes, and mentoring other developers.

### So, what’s the hardest part about being a development team lead?

 <%= partial "includes/blog/content-newsletter-cta", locals: { variant: "b" } %>

Due to the nature of their work, the challenges development team leads face often cross into several domains.

#### Vague requirements and poor communication

It can be difficult to know the status of certain requirements when other team members don't update the various tools that are being used. Important information can get lost along the way, which often leads to repetitive discussions or fixing incorrect work. Many of the people we spoke with are looking for ways to have this information readily accessible and consistently communicated throughout their teams.

> "Sometimes the back and forth can be annoying, when the requirements aren’t clear and I have to go back a step to understand what is going on or a component is not what I wanted. At a previous company, the back and forth was especially drawn out since the team did not work closely together. At [my current] company, this problem isn’t as severe since I work closely with the team and can quickly ask for clarification if I need to. Working more efficiently saves a lot of time."

####  Difficulty making accurate estimations of timeline and capacity

A team lead must have a good understanding of the skillsets available on their team and use this insight to balance business objectives. In order to get a better sense of the experience levels of different team members, they often hold one-on-one meetings or conduct reviews during and after a development cycle.

> " ... This goes back to the burndown chart – if it's being used correctly, it can help you see where you’ll end up. In order for that to happen, you need your estimations to be accurate. And in order for _that_ to happen you need to figure out the accuracy of the baseline and experience of the developer. For example, someone who is more junior has less of a reference point. I have to assign extra points to stories, if there are unknown variables."

#### Delivering on time

When demand surpasses current capacity, it can be stressful to resolve existing problems without creating new issues that result from hasty work. It can also be difficult to explain technical limitations to stakeholders who are not involved in the development process.

> "Someone might see a code review request but feel conflicted since they only have two days left to finish their own tasks. So sometimes testers and customers are waiting on these code reviews to move forward ... The biggest thing would be having all those tickets, all of those changes, closely correlated with the actual changes in Git. 'For this particular feature, here are all the changes in Git.' You don’t have to read the codebase or fire up the whole application. You have the information all in one place and don’t need to hunt down information."

#### Changing mindsets in organizations to adopt faster, iterative approaches

Some development teams are slowed down by inefficient toolchains or outdated workflows because their organizations are resistant to change and adopting new practices. Introducing new ideas and methodologies can be an especially complex process in organizations that create products for industries with more restrictions and regulations than others.

> "Most blockers that arise are put in their own way. I would prefer to iterate while they rather plan everything out for long periods of time. Their own processes get in their way because they don’t think they can move faster. Many of their processes are filled with errors and take days or weeks. They’ve always done things a certain way and are not really willing to make a change."

### What motivates a development team lead?

One of the biggest goals for many development team leads is the drive to continually optimize processes and deliver value to the product. They must also build a level of communication that enables them to assign tasks to the appropriate people, explain why certain feature requests are or are not feasible, and continue to implement strategic solutions.

### What’s the best part about being a development team lead?

The best part of being a Development Team Lead is problem solving on a variety of levels – from tools to methodologies to team relations and more. When teams are well supported by their leaders and organizations, they are better equipped to meet the expectations that will move both the product and business forward!

## The persona

[![Delaney, Development Team Lead persona](/images/blogimages/delaney-dev-team-lead-persona.png)](/handbook/marketing/strategic-marketing/roles-personas#delaney-development-team-lead){: .center}

### Want to share your experiences of GitLab with me?

Join [GitLab First Look](/community/gitlab-first-look/) and help us build an even better picture of who GitLab’s users really are!

[Photo](https://unsplash.com/photos/atSaEOeE8Nk) by [Steven Lelham](https://unsplash.com/@slelham) on Unsplash
{: .note}
